<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>frontend documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">frontend documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content class">
                   <div class="content-data">











<ol class="breadcrumb">
  <li>Classes</li>
  <li>ModelButton</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>e2e/page-object/operation/parameters/election-page-properties/election-page-properties-edit.po.ts</code>
        </p>

            <p class="comment">
                <h3>Description</h3>
            </p>
            <p class="comment">
                <p>Object representing a model button</p>

            </p>




            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>
                <tr>
                    <td class="col-md-4">
                        <h6><b>Properties</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#root">root</a>
                            </li>
                        </ul>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                <a href="#click">click</a>
                            </li>
                            <li>
                                <a href="#clickOnDelete">clickOnDelete</a>
                            </li>
                        </ul>
                    </td>
                </tr>





                    <tr>
                        <td class="col-md-4">
                            <h6><b>Accessors</b></h6>
                        </td>
                    </tr>
                    <tr>
                        <td class="col-md-4">
                            <ul class="index-list">
                                <li>
                                    <a href="#present">present</a>
                                </li>
                                <li>
                                    <a href="#hasDelete">hasDelete</a>
                                </li>
                            </ul>
                        </td>
                    </tr>
        </tbody>
    </table>
</section>

            <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(modelList: ElementFinder, modelName: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="100" class="link-to-prism">e2e/page-object/operation/parameters/election-page-properties/election-page-properties-edit.po.ts:100</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>modelList</td>
                                                  
                                                        <td>
                                                                    <code>ElementFinder</code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>modelName</td>
                                                  
                                                        <td>
                                                                    <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>

            <section>
    
        <h3 id="inputs">
            Properties
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="root"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            root
                            </b>
                            <a href="#root"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>root:     <code>ElementFinder</code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code>ElementFinder</code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="100" class="link-to-prism">e2e/page-object/operation/parameters/election-page-properties/election-page-properties-edit.po.ts:100</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
</section>

            <section>
    
        <h3 id="methods">
            Methods
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="click"></a>
                        <span class="name">
                            <b>
                            click
                            </b>
                            <a href="#click"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>click()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="110" class="link-to-prism">e2e/page-object/operation/parameters/election-page-properties/election-page-properties-edit.po.ts:110</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >any</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="clickOnDelete"></a>
                        <span class="name">
                            <b>
                            clickOnDelete
                            </b>
                            <a href="#clickOnDelete"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>clickOnDelete()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="114" class="link-to-prism">e2e/page-object/operation/parameters/election-page-properties/election-page-properties-edit.po.ts:114</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >any</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>






            <section>
    <h3 id="accessors">
        Accessors
    </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="present"></a>
                        <span class="name"><b>present</b><a href="#present"><span class="icon ion-ios-link"></span></a></span>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <span class="accessor"><b>get</b><code>present()</code></span>
                    </td>
                </tr>
                            <tr>
                                <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="106" class="link-to-prism">e2e/page-object/operation/parameters/election-page-properties/election-page-properties-edit.po.ts:106</a></div>
                                </td>
                            </tr>

            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="hasDelete"></a>
                        <span class="name"><b>hasDelete</b><a href="#hasDelete"><span class="icon ion-ios-link"></span></a></span>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <span class="accessor"><b>get</b><code>hasDelete()</code></span>
                    </td>
                </tr>
                            <tr>
                                <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="118" class="link-to-prism">e2e/page-object/operation/parameters/election-page-properties/election-page-properties-edit.po.ts:118</a></div>
                                </td>
                            </tr>

            </tbody>
        </table>
</section>
    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { browser, by, ElementFinder } from &#x27;protractor&#x27;;
import { Cache } from &#x27;../../../cache.po&#x27;;
import { Card } from &#x27;../../../../shared/card&#x27;;
import { promise } from &#x27;selenium-webdriver&#x27;;
import { Button } from &#x27;../../../../shared/button&#x27;;
import { SelectField } from &#x27;../../../../shared/select-field&#x27;;
import { InputField } from &#x27;../../../../shared/input-field&#x27;;
import { waitForInvisibility } from &#x27;../../../../shared/e2e.utils&#x27;;

/**
 * Page object for the election properties edit section.
 */
export class ElectionPropertiesEdit {

  /**
   * @returns {Card} the edit section element itself
   */
  static get root(): Card {
    return Cache.card(&#x27;electionPagePropertiesEdit&#x27;);
  }

  /**
   * @returns {ElementFinder} the element displaying the list of election&#x27;s mapping
   */
  static get mappings(): ElementFinder {
    return Cache.element(&#x27;electionPropertiesMappings&#x27;, by.tagName(&#x27;election-page-properties-mapping&#x27;));
  }

  /**
   * @returns {ElementFinder} the element displaying the list of models
   */
  static get models(): ElementFinder {
    return Cache.element(&#x27;electionPropertiesModels&#x27;, by.tagName(&#x27;election-page-properties-model-list&#x27;));
  }

  /**
   * @returns {Button} the [CREATE MODEL] button
   */
  static get createModelButton(): Button {
    return Cache.button(&#x27;addModel&#x27;);
  }

  /**
   * @returns {Button} the [BULK UPDATE] button
   */
  static get bulkUpdateButton(): Button {
    return Cache.button(&#x27;bulk-update-button&#x27;);
  }

  /**
   * Get the model button identified by its name
   *
   * @param {string} name the model&#x27;s name
   * @returns {ModelButton} the corresponding model button
   */
  static getModel(name: string) {
    return new ModelButton(this.models, name);
  }

  /**
   * Get he mapping for the given ballot
   *
   * @param {string} ballot the concerned ballot
   * @returns {ElectionMapping} the corresponding ballot mapping
   */
  static getMapping(ballot: string): ElectionMapping {
    return new ElectionMapping(this.mappings, ballot);
  }
}

/**
 * Object representing a ballot mapping
 */
export class ElectionMapping {
  private root: ElementFinder;
  private ballot: string;

  constructor(mappings: ElementFinder, ballot: string) {
    this.root &#x3D; mappings.element(by.id(ballot));
    this.ballot &#x3D; ballot;
  }

  get selectField() {
    return Cache.selectField(this.root.element(by.tagName(&#x27;mat-select&#x27;)), this.ballot);
  }

  get deleteButton() {
    return Cache.button(&#x60;electionMappingDeleteButton-${this.ballot}&#x60;, this.root.element(by.id(&#x27;deleteButton&#x27;)));
  }

  get present(): promise.Promise&lt;boolean&gt; {
    return this.root.isPresent();
  }
}

/**
 * Object representing a model button
 */
export class ModelButton {
  private root: ElementFinder;

  constructor(modelList: ElementFinder, modelName: string) {
    this.root &#x3D; modelList.element(by.id(modelName));
  }

  get present() {
    return this.root.isPresent();
  }

  click() {
    return this.root.element(by.className(&#x27;model-name&#x27;)).click();
  }

  clickOnDelete() {
    return this.root.element(by.className(&#x27;model-delete&#x27;)).click();
  }

  get hasDelete() {
    return this.root.element(by.className(&#x27;model-delete&#x27;)).isPresent();
  }
}

/**
 * Page objet representing the bulk update dialog
 */
export class BulkUpdatePopup {

  static get root(): ElementFinder {
    return Cache.element(&#x27;electionModelBulkMapping&#x27;, by.tagName(&#x27;election-page-bulk-update&#x27;));
  }

  static get acceptButton(): Button {
    return Cache.button(&#x27;accept&#x27;);
  }

  static get cancelButton(): Button {
    return Cache.button(&#x27;cancel&#x27;);
  }

  static get modelSelect(): SelectField {
    return Cache.selectField(this.root.element(by.id(&#x27;model-select&#x27;)), &#x27;electionModelBulkMapping&#x27;);
  }

  static get present(): promise.Promise&lt;boolean&gt; {
    return this.root.isPresent();
  }

  static toggleAll(): void {
    this.root.element(by.css(&#x27;mat-header-row mat-checkbox&#x27;)).click();
  }

  static toggle(ballot: string): void {
    this.root.element(by.id(&#x60;cb#${ballot}&#x60;)).click();
  }

  static get allBallots(): promise.Promise&lt;string[]&gt; {
    return this.root.all(by.className(&#x27;ballot-name&#x27;))
      .map(elementFinder &#x3D;&gt; elementFinder.getText());
  }

  static get filterInput(): InputField {
    return Cache.inputField(this.root, &#x27;electionModelBulkMapping&#x27;, &#x27;search-input&#x27;, false);
  }

  static waitForInvisibility() {
    waitForInvisibility(this.root);
  }
}

</code></pre>
    </div>
</div>







                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'class';
            var COMPODOC_CURRENT_PAGE_URL = 'ModelButton.html';
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
